package edu.upc.essi.petrinets;

import java.util.Collection;
import java.util.UUID;

public abstract class Node {
	
	protected UUID m_id;
	protected String m_label;
	protected Collection<Arc> m_incomingArcs;
	protected Collection<Arc> m_outgoingArcs;
	
	public Node(String label){
		m_label = label;
		m_id = UUID.randomUUID();
	}
	
	public UUID getID(){
		return m_id;
	}
	
	public String getLabel(){
		return m_label;
	}
	
	public boolean isTransition(){
		return false;
	}
	
	public boolean isPlace(){
		return false;
	}
	
	public Collection<Arc> getIncomingArcs(){
		return m_incomingArcs;
	}
	
	public Collection<Arc> getOutgoingArcs(){
		return m_outgoingArcs;
	}
	
	public void addIncomingArc(Arc arc){
		m_incomingArcs.add(arc);
	}
	
	public void addOutgoingArc(Arc arc){
		m_outgoingArcs.add(arc);
	}
	
	public boolean deleteIncomingArc(Arc arc){
		return m_incomingArcs.remove(arc);
	}
	
	public boolean deleteOutgoingArc(Arc arc){
		return m_outgoingArcs.remove(arc);
	}

}
