package edu.upc.essi.petrinets;

import java.util.Collection;
import java.util.HashSet;
import java.util.UUID;

public class Petrinet {
	
	private UUID m_id;
	private String m_label;
	private Place m_startPlace;
	
	public Petrinet(String label, Place startPlace){
		if (label == null || startPlace == null){
			//Throws exception
		}
		if (!m_startPlace.getIncomingArcs().isEmpty()){
			//Throws exception - start place should not have incoming arcs
		}
		m_label = label;
		m_startPlace = startPlace;
	}
	
	public UUID getID(){
		return m_id;
	}
	
	public String getLabel(){
		return m_label;
	}
	
	public Place getStartPlace(){
		return m_startPlace;
	}
	
	public Collection<Node> getNodes(){
		Collection<Node> nodeCollection = new HashSet<>();
		for(Arc arc: m_startPlace.getOutgoingArcs()){
			nodeCollection.add(arc.getTarget());
		}
		return nodeCollection;
	}

}
