// Copyright (C) 2014 by Jorge Munoz-Gama. All rights reserved. 
// Released under the terms of the Lesser GNU General Public License (L-GPL) version 2 or later.

package org.processmininguc.balsa.models;

import java.util.List;

import org.processmininguc.balsa.models.structures.SimpleADChange;

public interface ActivityDiagram {
	
	/**
	 * Returns the name of the activity diagram.
	 * @return
	 */
	public String getName();
	
	/**
	 * Returns the list of activities or tasks that are part of the activity diagram
	 * @return
	 */
	public List<ActivityDiagramActivity> getActivities();
		
	public ActivityDiagramInitialNode getInitialNode();
	
	public List<Annotation> getNotes();
	
	public List<SimpleADChange> getSimpleChanges();

}
