// Copyright (C) 2014 by Jorge Munoz-Gama. All rights reserved. 
// Released under the terms of the Lesser GNU General Public License (L-GPL) version 2 or later.

package org.processmininguc.balsa.models;

import java.util.List;

import org.processmininguc.balsa.models.structures.ArtifactMultRel;

public interface Artifact {

	public StateMachineDiagram getStateMachineDiagram();

	public String getName();

	public String toString();

	boolean isContextIndependent();
	
	/**
	 * Returns a list of ArtifactMultRel, a data structure containing a string representing an artifact name and the maximum
	 * cardinality allowed in the relationship between these two artifacts.
	 * @return
	 */
	public List<ArtifactMultRel> getContext();

}
