// Copyright (C) 2014 by Jorge Munoz-Gama. All rights reserved. 
// Released under the terms of the Lesser GNU General Public License (L-GPL) version 2 or later.

package org.processmininguc.balsa.models;

import stateMachine.Transition.EventDepCondType;

public interface StateMachineDiagramTransition extends Comparable<StateMachineDiagramTransition> {

	boolean isInitial();

	boolean isFinal();

	StateMachineDiagramState getSourceNode();

	StateMachineDiagramState getTargetNode();

	StateMachineDiagramEvent getEvent();

	StateMachineDiagramCondition getGuardCondition();
	
	EventDepCondType getTag();
	
	StateMachineDiagramEffect getSmdEffect();

}
