package org.processmininguc.balsa.models.impl.smadu;

import java.util.List;

import org.processmininguc.balsa.models.ActivityDiagramArc;
import org.processmininguc.balsa.models.ActivityDiagramElement;
import org.processmininguc.balsa.models.ActivityDiagramGateway;
import org.processmininguc.utils.Utils;

import activity.ActivityEdge;
import activity.DecisionNode;

public class ActivityDiagramDecisionNodeImpl extends DecisionNode implements ActivityDiagramGateway{
	
	protected ActivityDiagramDecisionNodeImpl() {
		super();
	}

	protected ActivityDiagramDecisionNodeImpl(ActivityEdge incoming, ActivityEdge outgoing) {
		super(incoming,outgoing);
	}
	
	protected ActivityDiagramDecisionNodeImpl(ActivityEdge incoming, List<ActivityEdge> outgoing) {
		super(incoming,outgoing);
	}

	public boolean isActivity() {
		return isAction();
	}

	public boolean isFinalNode() {
		return isFinal();
	}

	public List<ActivityDiagramArc> getIncomingArcs() {
		return Utils.convert(this.getIncomingEdges());
	}

	public List<ActivityDiagramArc> getOutgoingArcs() {
		return Utils.convert(this.getOutgoingEdges());
	}

	public List<ActivityDiagramElement> getPreviousElements() {
		return Utils.convert(this.getPreviousNodes());
	}

	public List<ActivityDiagramElement> getNextElements() {
		return Utils.convert(this.getNextNodes());
	}
	

}
