package org.processmininguc.balsa.models.impl.smadu;
import java.util.List;

import org.processmininguc.balsa.models.ActivityDiagramArc;
import org.processmininguc.balsa.models.ActivityDiagramElement;
import org.processmininguc.balsa.models.ActivityDiagramGateway;
import org.processmininguc.utils.Utils;

import activity.ActivityEdge;
import activity.MergeNode;

public class ActivityDiagramMergeNodeImpl extends MergeNode implements ActivityDiagramGateway {

	protected ActivityDiagramMergeNodeImpl() {
		super();
	}
	
	protected ActivityDiagramMergeNodeImpl(ActivityEdge incoming, ActivityEdge outgoing) {
		super(incoming,outgoing);
	}

	public ActivityDiagramMergeNodeImpl(List<ActivityEdge> incoming, ActivityEdge outgoing) {
		super(incoming,outgoing);
	}

	public boolean isActivity() {
		return this.isAction();
	}

	public boolean isFinalNode() {
		return this.isFinal();
	}

	public List<ActivityDiagramArc> getIncomingArcs() {
//		List<ActivityEdge> edgeList = this.getIncomingEdges();
//		List<ActivityDiagramArc> arcList = new LinkedList<ActivityDiagramArc>();
//		for(ActivityEdge edge: edgeList){
//			arcList.add((ActivityDiagramArc)edge);
//		}
		return Utils.convert(this.getIncomingEdges());
	}

	public List<ActivityDiagramArc> getOutgoingArcs() {
//		List<ActivityEdge> edgeList = this.getOutgoingEdges();
//		List<ActivityDiagramArc> arcList = new LinkedList<ActivityDiagramArc>();
//		for(ActivityEdge edge: edgeList){
//			arcList.add((ActivityDiagramArc)edge);
//		}
		return Utils.convert(this.getOutgoingEdges());
	}

	public List<ActivityDiagramElement> getPreviousElements() {
//		List<ActivityNode> actNodeList = this.getPreviousNodes();
//		List<ActivityDiagramElement> actElementList = new LinkedList<ActivityDiagramElement>();
//		for(ActivityNode actNode: actNodeList){
//			actElementList.add((ActivityDiagramElement)actNode);
//		}
		return Utils.convert(this.getPreviousNodes());
	}

	public List<ActivityDiagramElement> getNextElements() {
//		List<ActivityNode> actNodeList = this.getNextNodes();
//		List<ActivityDiagramElement> actElementList = new LinkedList<ActivityDiagramElement>();
//		for(ActivityNode actNode: actNodeList){
//			actElementList.add((ActivityDiagramElement)actNode);
//		}
		return Utils.convert(this.getNextNodes());
	}

}
