package org.processmininguc.balsa.models.impl.smadu;

import java.util.LinkedList;
import java.util.List;

import org.processmininguc.balsa.models.Artifact;
import org.processmininguc.balsa.models.StateMachineDiagram;
import org.processmininguc.balsa.models.structures.ArtifactMultRel;

public class ArtifactImpl implements Artifact {
	
	private String m_name;
	private StateMachineDiagram m_smd;
	private List<ArtifactMultRel> m_relMult;
	
	protected ArtifactImpl(String name, StateMachineDiagram smd){
		m_name = name;
		m_relMult = new LinkedList<ArtifactMultRel>();
		m_smd = smd;
	}

	public StateMachineDiagram getStateMachineDiagram() {
		return m_smd;
	}

	public String getName() {
		return m_name;
	}

	/**
	 * Will return false if the artifact has one or several multiplicity relationships, indicating that it can be associated to a 
	 * maximum number of artifacts of a certain type. Otherwise it returns true.
	 */
	public boolean isContextIndependent() {
		boolean result;
		if (m_relMult.isEmpty()){
			result = true;
		}
		else{
			result = false;
		}
		return result;
	}
	
	public void addRelationshipMult(ArtifactMultRel multRel){
		m_relMult.add(multRel);
	}
	
	public void addArtifactMultRel(String artName, int maxCard){
		ArtifactMultRel artMultRel = new ArtifactMultRel(artName,maxCard);
		m_relMult.add(artMultRel);
	}
	
	public List<ArtifactMultRel> getContext(){
		return m_relMult;
	}
	
	public List<ArtifactMultRel> getArtifactMultRel(){
		return m_relMult;
	}
	
	public String toString(){
		return m_name;
	}
	
	


}
