package org.processmininguc.balsa.models.impl.smadu;

import java.util.LinkedList;
import java.util.List;

import org.processmininguc.balsa.models.ActivityDiagram;
import org.processmininguc.balsa.models.Artifact;
import org.processmininguc.balsa.models.Balsa;
import org.processmininguc.balsa.models.BalsaFactory;
import org.processmininguc.balsa.models.StateMachineDiagram;

/**
 * Factory to create the BALSA components using the SMADU metamodel
 * @author Montse
 *
 */
public class BalsaFactorySMADU implements BalsaFactory{
	
	public Balsa createBalsa(){
		return new BalsaImpl();
	}
	
	/**
	 * Creates also the artifacts.
	 * @param smdList
	 * @param adList
	 * @return
	 */
	public Balsa createBalsa(List<StateMachineDiagram> smdList, List<ActivityDiagram> adList){
		List<Artifact> artList = new LinkedList<>();
		for (StateMachineDiagram smd: smdList){
			String smdName = smd.getName().trim();
			Artifact artifact = new ArtifactImpl(smdName,smd);
			artList.add(artifact);
		}
		return new BalsaImpl(artList,smdList,adList);
	}

	public Artifact createArtifact(String name) {
		// TODO Auto-generated method stub
		return null;
	}

	public StateMachineDiagram createStateMachine() {
		// TODO Auto-generated method stub
		return null;
	}

	public ActivityDiagram createActivityDiagram() {
		// TODO Auto-generated method stub
		return null;
	}
	
//	public Artifact createArtifact(String id, String name, StateMachineDiagram stateMachineDiagram){
//		return new ArtifactImpl(id, name, stateMachineDiagram);
//	}
//
//	public StateMachineDiagram createStateMachine() {
//		// TODO Auto-generated method stub
//		return null;
//	}
//
//	public ActivityDiagram createActivityDiagram() {
//		// TODO Auto-generated method stub
//		return null;
//	}
	
	/**
	 * Deals with additional tasks when creating the BALSA model
	 *
	 */
	private void postProcess() {
		
		

		
	}
	
	

}
