package org.processmininguc.balsa.models.impl.smadu;

import org.processmininguc.balsa.models.structures.ComparisonType;

public class StateMachineDiagramArtCondImpl extends StateMachineDiagramCondImpl {
	
	String m_targetArtifact;
	ComparisonType m_compOp;
	int m_number;


	/**
	 * 
	 * @param smdCondImpl
	 * @param targetArtifact
	 * @param compOp - Should be a valid math operator: <,>,=,<=,>= represented by ComparisonType
	 * @param number
	 */
	protected StateMachineDiagramArtCondImpl(StateMachineDiagramCondImpl smdCondImpl, String targetArtifact, ComparisonType compOp, int number){
		super(smdCondImpl.getCondition());
		m_targetArtifact = targetArtifact;
		m_compOp = compOp;
		m_number = number;
	}
	
	/**
	 * 
	 * @param cond
	 * @param targetArtifact
	 * @param compOp - Should be a valid math operator: <,>,=,<=,>= represented by ComparisonType
	 * @param number
	 */
	protected StateMachineDiagramArtCondImpl(String cond, String targetArtifact, ComparisonType compOp, int number) {
		super(cond);
		m_targetArtifact = targetArtifact;
		m_compOp = compOp;
		m_number = number;
	}

	/**
	 * Returns the name of the target artifact.
	 * @return
	 */
	public String getTargetArtifact() {
		return m_targetArtifact;
	}

	/**
	 * Returns the comparison type.
	 * @return
	 */
	public ComparisonType getMathOp() {
		return m_compOp;
	}

	/**
	 * Returns the number implied in the comparison.
	 * @return
	 */
	public int getNumber() {
		return m_number;
	}
	
	/**
	 * Returns true 
	 */
	public boolean referencesArtifactNum() {
		return true;
	}
	

}
