package org.processmininguc.balsa.models.impl.smadu;

import java.util.List;

import org.processmininguc.balsa.models.StateMachineDiagramState;
import org.processmininguc.balsa.models.StateMachineDiagramTransition;
import org.processmininguc.utils.Utils;

import stateMachine.Pseudostate;
import stateMachine.PseudostateKind;
import stateMachine.Transition;
import stateMachine.Vertex;

public class StateMachineDiagramPseudostateImpl extends Pseudostate implements StateMachineDiagramStateInt {
	
	protected StateMachineDiagramPseudostateImpl(PseudostateKind kind){
		super(kind);
	}

	public List<StateMachineDiagramTransition> getIncomingTransition() {
		List<Transition> transList = this.getIncoming();
		List<StateMachineDiagramTransition> smdTransList = Utils.convert(transList);
		return smdTransList;
	}

	public List<StateMachineDiagramTransition> getOutgoingTransition() {
		List<Transition> transList = this.getOutgoing();
		List<StateMachineDiagramTransition> smdTransList = Utils.convert(transList);
		return smdTransList;
	}

	public List<StateMachineDiagramState> getNextStates() {
		List<Vertex> vertexList = this.getNextVertices();
		List<StateMachineDiagramState> smdStates = Utils.convert(vertexList);
		return smdStates;
	}

	public List<StateMachineDiagramState> getPreviousStates() {
		List<Vertex> vertexList = this.getPreviousVertices();
		List<StateMachineDiagramState> smdStates = Utils.convert(vertexList);
		return smdStates;
	}

}
