package org.processmininguc.utils;

import java.util.LinkedList;
import java.util.List;

public class Utils {
	
	/**
	 * Converts a list of a given type T1 to a list of type T2.
	 * It should only be used when one can ensure that the elements of type T1 are also of type T2.
	 * @param l List containing the elements of type T1 that will be converted.
	 * @return A list containing the elements of l converted into type T2.
	 */
	@SuppressWarnings("unchecked")
	public static <T1, T2> List<T2> convert(List<T1> l)
	{
		List<T2> out = new LinkedList<T2>();
		for(T1 element: l){
			out.add((T2)element);
		}
		return out;
	}
	
	public static <T1, T2> void convert2(List<T1> l, List<T2> out)
	{
		for(T1 element: l){
			@SuppressWarnings("unchecked")
			T2 element2 = (T2)element;
			out.add(element2);
		}
	}

}
